aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
authorcbdev <cb@cbcdn.com>2020-03-11 20:44:24 +0100
committercbdev <cb@cbcdn.com>2020-03-11 20:44:24 +0100
commit20803bd7d7578706ad55b56cf1a4d8865b5c1285 (patch)
tree24672f1f2b94569d43e9821010690b15b8a7b414
parentc15ac89a33b6f6f51ac0c3da7a86dc43c8a9321a (diff)
downloadmidimonster-20803bd7d7578706ad55b56cf1a4d8865b5c1285.tar.gz
midimonster-20803bd7d7578706ad55b56cf1a4d8865b5c1285.tar.bz2
midimonster-20803bd7d7578706ad55b56cf1a4d8865b5c1285.zip
Restructure CI spellchecking
-rw-r--r--.travis-ci.sh80
-rw-r--r--.travis.yml46
2 files changed, 43 insertions, 83 deletions
diff --git a/.travis-ci.sh b/.travis-ci.sh
index 8008026..e9e3df3 100644
--- a/.travis-ci.sh
+++ b/.travis-ci.sh
@@ -1,66 +1,42 @@
#!/bin/bash
-# This script is triggered from the script section of .travis.yml
-# It runs the appropriate commands depending on the task requested.
+if [ "$TASK" = "spellcheck" ]; then
+ result=0
+ # Create list of files to be spellchecked
+ spellcheck_files=$(find -type f | grep -v ".git/")
-set -e
+ # Run spellintian to find spelling errors
+ sl_results=$(spellintian $spellcheck_files 2>&1)
-SPELLINGBLACKLIST=$(cat <<-BLACKLIST
--wholename "./.git/*"
-BLACKLIST
-)
+ sl_errors=$(wc -l <<< "$sl_results")
+ sl_errors_dups=$((grep "\(duplicate word\)" | wc -l) <<< "$sl_results")
+ sl_errors_nodups=$((grep -v "\(duplicate word\)" | wc -l) <<< "$sl_results")
-if [[ $TASK = 'spellintian' ]]; then
- # run spellintian only if it is the requested task, ignoring duplicate words
- spellingfiles=$(eval "find ./ -type f -and ! \( \
- $SPELLINGBLACKLIST \
- \) | xargs")
- # count the number of spellintian errors, ignoring duplicate words
- spellingerrors=$(zrun spellintian $spellingfiles 2>&1 | grep -v "\(duplicate word\)" | wc -l)
- if [[ $spellingerrors -ne 0 ]]; then
- # print the output for info
- zrun spellintian $spellingfiles | grep -v "\(duplicate word\)"
- echo "Found $spellingerrors spelling errors via spellintian, ignoring duplicates"
- exit 1;
+ if [ "$sl_errors" -ne 0 ]; then
+ printf "Spellintian found %s errors (%s spelling, %s duplicate words):\n\n" "$sl_errors" "$sl_errors_nodups" "$sl_errors_dups"
+ printf "%s\n\n" "$sl_results"
+ result=1
else
- echo "Found $spellingerrors spelling errors via spellintian, ignoring duplicates"
- fi;
-elif [[ $TASK = 'spellintian-duplicates' ]]; then
- # run spellintian only if it is the requested task
- spellingfiles=$(eval "find ./ -type f -and ! \( \
- $SPELLINGBLACKLIST \
- \) | xargs")
- # count the number of spellintian errors
- spellingerrors=$(zrun spellintian $spellingfiles 2>&1 | wc -l)
- if [[ $spellingerrors -ne 0 ]]; then
- # print the output for info
- zrun spellintian $spellingfiles
- echo "Found $spellingerrors spelling errors via spellintian"
- exit 1;
- else
- echo "Found $spellingerrors spelling errors via spellintian"
- fi;
-elif [[ $TASK = 'codespell' ]]; then
- # run codespell only if it is the requested task
- spellingfiles=$(eval "find ./ -type f -and ! \( \
- $SPELLINGBLACKLIST \
- \) | xargs")
- # count the number of codespell errors
- spellingerrors=$(zrun codespell --check-filenames --check-hidden --quiet 2 --regex "[a-zA-Z0-9][\\-'a-zA-Z0-9]+[a-zA-Z0-9]" $spellingfiles 2>&1 | wc -l)
- if [[ $spellingerrors -ne 0 ]]; then
- # print the output for info
- zrun codespell --check-filenames --check-hidden --quiet 2 --regex "[a-zA-Z0-9][\\-'a-zA-Z0-9]+[a-zA-Z0-9]" $spellingfiles
- echo "Found $spellingerrors spelling errors via codespell"
- exit 1;
+ printf "Spellintian reports no errors\n"
+ fi
+
+ # Run codespell to find some more
+ cs_results=$(codespell --check-filenames --check-hidden --quiet 2 --regex "[a-zA-Z0-9][\\-'a-zA-Z0-9]+[a-zA-Z0-9]" $spellcheck_files 2>&1)
+ cs_errors=$(wc -l <<< "$cs_results")
+ if [ "$cs_errors" -ne 0 ]; then
+ printf "Codespell found %s errors:\n\n" "$cs_errors"
+ printf "%s\n\n" "$cs_results"
+ result=1
else
- echo "Found $spellingerrors spelling errors via codespell"
- fi;
-elif [[ $TASK = 'sanitize' ]]; then
+ printf "Codespell reports no errors\n"
+ fi
+ exit "$result"
+elif [ "$TASK" = 'sanitize' ]; then
# Run sanitized compile
travis_fold start "make_sanitize"
make sanitize;
travis_fold end "make_sanitize"
-elif [[ $TASK = 'windows' ]]; then
+elif [ "$TASK" = 'windows' ]; then
travis_fold start "make_windows"
make windows;
make -C backends lua.dll
diff --git a/.travis.yml b/.travis.yml
index b9b6969..48b4b71 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -12,8 +12,6 @@ script:
addons:
apt:
packages: &base_build
- # This is the absolute minimum for configure to pass
- # Non C++ based tasks use it so they can run make builtfiles
- ccache
packages: &core_build
# This is all the bits we need to enable all options
@@ -36,6 +34,11 @@ addons:
packages: &core_build_windows
- *core_build
- mingw-w64
+ packages: &linters
+ - lintian
+ - codespell
+ - shellcheck
+ - cloc
jobs:
fast_finish: true
@@ -74,30 +77,6 @@ jobs:
apt:
packages:
- *core_build_clang_latest
- - os: linux
- dist: bionic
- env: TASK='spellintian'
- addons:
- apt:
- packages:
- - *core_build
- - moreutils
- - os: linux
- dist: bionic
- env: TASK='spellintian-duplicates'
- addons:
- apt:
- packages:
- - *core_build
- - moreutils
- - os: linux
- dist: bionic
- env: TASK='codespell'
- addons:
- apt:
- packages:
- - *core_build
- - moreutils
- os: osx
osx_image: xcode10.2
compiler: clang
@@ -116,10 +95,18 @@ jobs:
allow_failures:
- os: linux
dist: bionic
- env: TASK='spellintian-duplicates'
+ env: TASK='codesmell'
+ addons:
+ apt:
+ packages:
+ - *linters
- os: linux
dist: bionic
- env: TASK='codespell'
+ env: TASK='spellcheck'
+ addons:
+ apt:
+ packages:
+ - *linters
env:
global:
@@ -136,9 +123,6 @@ cache:
before_cache:
- ccache -s # see how many hits ccache got
-install:
- - if [ "$TASK" = "codespell" ]; then pip install --user git+https://github.com/codespell-project/codespell.git; fi
-
before_install:
# Travis clones with --branch, which omits tags. Since we use them for the version string at build time, fetch them
- git pull --tags